Scriptname EABNPC extends activemagiceffect  

Actor targ
Bool HitDelay
Int[] eqslot
int NowEquip = 0
float EquipInterval = 0.25
Form PreSource = None
bool EstrusInstall = false
Event OnEffectStart(Actor akTarget, Actor akCaster)
	targ = akTarget
	if (targ.IsPlayerTeammate() || !targ.HasKeywordString("ActorTypeNPC"))
		;debug.notification("EABNPC OnEffectO:"+ targ.GetLeveledActorBase().GetName()) 
		GoToState("Dead")
		return
	endif
	;debug.notification("EABNPC OnEffect:"+ targ.GetLeveledActorBase().GetName()) 
	StartUpProcess()
	if Game.GetModByName("zzEstrus.esp") < 255
		EstrusInstall = true
	endif
	GoToState("Alive")
EndEvent

Function StartUpProcess()
	Form[] stwkForm = new Form[128]
	stwkForm = PO3_SKSEfunctions.AddAllEquippedItemsToArray(targ)
	int num = stwkForm.Length
	int ct = 0
	while (ct < num)
		if (stwkForm[ct] as Armor)
			Armor thisArmor = stwkForm[ct] as Armor
			int slotmask = thisArmor.GetSlotMask()
			NowEquip = Math.LogicalOr(NowEquip, slotmask)
		endif
		ct += 1
	endWhile
EndFunction

State Alive

	Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
		if (PreSource ==  akSource)
			return
		endif

		if (EABNpcEnable.GetValue() == 0)
			return
		endif
		if (targ.HasKeyWordString("SexLabActive"))
			return
		endif
		if (EstrusInstall)
			Armor amr = targ.GetWornForm(0x40000000) as Armor
			if (amr)
				string name = amr.GetName()
				int idx = StringUtil.Find(name, "zzEstrus")
				if (idx != -1)
					return
				endif
			endif
		endif
		ActorBase targBase = targ.GetLeveledActorBase()
		float NPCSex = EABNPCSex.GetValue()
		int sex = targBase.GetSex()
		if (NPCSex != 2)
			if ( sex != NPCSex )
				return
			endif
		endif
		;debug.notification("EABNPC OnHit!!:"+ targBase.GetName()) 
		If (!HitDelay && akAggressor && akSource as Weapon)
			if (!abHitBlocked || (abHitBlocked && EABUnblockMode.GetValue() == 1))

				int rnd = PO3_SKSEfunctions.GenerateRandomInt(0, 1000)
				int rate
				if (abPowerAttack)
					rate = (EABRatePA.GetValue() * 10) as int
				else
					rate = (EABRate.GetValue() * 10) as int
				endif
			;	self.log(rnd + ", " + rate)
				if (rnd > rate)
					return
				endif
				
				HitDelay = true

				bool EnchFlag = false
				
				Form[] armors = GetEeuippedArmors(targ)
				if (armors)
					if (EABReEquipMode.GetValue() == 1)
						EquipInterval = EABEquipInterval.GetValue()
						RegisterForSingleUpdateGameTime(EquipInterval)
					endif
					int count = armors.Find(none, 0)
					int idx = PO3_SKSEfunctions.GenerateRandomInt(0, count - 1)
					Form targetItem = armors[idx]
					String targetName = targetItem.Getname()

					; check for item enchantment
					if ( (targetItem as Armor).GetEnchantment() || WornObject.GetEnchantment(targ, 0, eqslot[idx]) )
						enchFlag = true
					endif
					int BreakMode = EABNPCBreakMode.GetValue() as int
					if (BreakMode == 3)
						BreakMode = PO3_SKSEfunctions.GenerateRandomInt(0, 2)
					endif
				
					int degraRet = Degradation(targ, idx, abPowerAttack, targetItem)
					if (BreakMode == 1)
						if (enchFlag == true)
							if(degraRet == 1)
								self.log(targBase.GetName()+""+targetName + "򉻂")
							elseif(degraRet == 2)
								PlayFx(targetItem)
								targ.UnEquipItem(targetItem, false, true)
								self.log(targBase.GetName()+""+targetName + "ꂽ")
								NowEquip = Math.LogicalAnd(NowEquip, Math.LogicalNot(eqslot[idx]))
							endif
						else
							if(degraRet == 1)
								self.log(targBase.GetName()+""+targetName + "򉻂")
							elseif(degraRet == 2)
								PlayFx(targetItem)
								targ.RemoveItem(targetItem, 1, true, none)
								self.log(targBase.GetName()+""+targetName + "ꂽ")
								NowEquip = Math.LogicalAnd(NowEquip, Math.LogicalNot(eqslot[idx]))
							endif
						endif
					elseif (BreakMode == 2)
						if (enchFlag == true)
							if(degraRet == 1)
								self.log(targBase.GetName()+""+targetName + "򉻂")
							elseif(degraRet == 2)
								PlayFx(targetItem)
								targ.UnEquipItem(targetItem, false, true)
								self.log(targBase.GetName()+""+targetName + "ꂽ")
								NowEquip = Math.LogicalAnd(NowEquip, Math.LogicalNot(eqslot[idx]))
							endif
						else
							if(degraRet == 1)
								self.log(targBase.GetName()+""+targetName + "򉻂")
							elseif(degraRet == 2)
								PlayFx(targetItem)
								targ.removeItem(targetItem, 1, true, none)
								ObjectReference obj = targ.PlaceAtMe(targetItem, 1, false, true)
								float fwork = 1.0
								if Game.GetModByName("ItsNotYourArmor.esp") < 255
									int rndweight = PO3_SKSEfunctions.GenerateRandomInt(0, 100)
									fwork = SetSwdHealth(fwork, rndweight)
									if (sex == 0)
										fwork = SetSwdFlag(fwork, 4)
									elseif (sex == 1)
										fwork = SetSwdFlag(fwork, 8)
									else
										fwork = SetSwdFlag(fwork, 2)
									endif
								else
									int rndswd = PO3_SKSEfunctions.GenerateRandomInt(0, 990)
									fwork = SetSwdHealth(fwork, rndswd)
									fwork = SetSwdFlag(fwork, 2)
								endif
								float fAngle = targ.GetAngleZ()
								float fx = targ.GetPositionX() + Math.Sin(fAngle) * 50.0
								float fy = targ.GetPositionY() + Math.Cos(fAngle) * 50.0
								float fz = targ.GetPositionZ() + 70.0
								obj.SetPosition(fx, fy, fz)
								obj.SetAngle(0, 0, fAngle)
								obj.SetItemHealthPercent(fwork)
								obj.EnableNoWait()
								self.log(targBase.GetName()+""+targetName + "hbv")
								NowEquip = Math.LogicalAnd(NowEquip, Math.LogicalNot(eqslot[idx]))
							endif
						endif
					else
						if(degraRet == 1)
							self.log(targBase.GetName()+""+targetName + "򉻂")
						elseif(degraRet == 2)
							PlayFx(targetItem)
							targ.UnEquipItem(targetItem, false, true)
							self.log(targBase.GetName()+""+targetName + "ꂽ")
							NowEquip = Math.LogicalAnd(NowEquip, Math.LogicalNot(eqslot[idx]))
						endif
					endif
				endif
				RegisterForSingleUpdate(2.0)
			Endif
		Endif
	EndEvent
	
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
		if !(akBaseObject as Armor)
			return
		endif
		int slotmask = (akBaseObject as Armor).GetSlotMask()
		float fwork = WornObject.GetItemHealthPercent(targ, 0, slotmask)
		fwork = SetSwdFlag(fwork, 2)
		WornObject.SetItemHealthPercent(targ, 0, slotmask, fwork)
	EndEvent
	
	Event OnUpdate()
		HitDelay = False
		PreSource = None
	EndEvent
	
	Event OnUpdateGameTime()
		;debug.notification("OnUpdateGameTime")
		if (targ.HasKeyWordString("SexLabActive"))
			RegisterForSingleUpdateGameTime(EquipInterval)
			return
		endif
		Armor amr = targ.GetWornForm(0x40000000) as Armor
		if (amr)
			string name = amr.GetName()
			int idx = StringUtil.Find(name, "zzEstrus")
			if (idx != -1)
				;debug.notification("EstrusғI")
				RegisterForSingleUpdateGameTime(EquipInterval)
				return
			endif
		endif
		Form[] inv = new Form[128]
		inv = PO3_SKSEFunctions.AddAllInventoryItemsToArray(targ)
		int num = inv.Length
		int ct = 0
		while(ct < num)
			if (inv[ct] as Armor)
				int wkslot = (inv[ct] as Armor).GetSlotMask()
				if (Math.LogicalAnd(NowEquip, wkslot) == 0)
					targ.EquipItem(inv[ct], false, true)
					NowEquip = Math.LogicalOr(NowEquip, wkslot)
				endif
			endif
			ct += 1
		endWhile
		;RegisterForSingleUpdateGameTime(EquipInterval)
	endEvent
	
	Event OnEffectFinish(Actor akTarget, Actor akCaster)
		;targ.RemoveSpell(EcchinaArmorBreak.EABNPCSpell)
		Utility.Wait(1.5)
		GoToState("Dead")
	EndEvent

EndState

State Dead
EndState

Function log(String msg)
	if (EABLogMode.GetValue() == 1)
		debug.notification("[EAB]" + msg)
	endif
EndFunction

int Function Degradation(Actor act, int index, bool PA, form Item)
	if (EABDegradationMode.GetValue() == 0)
		return 2
	endif
	float degraNum = EABDegradationNum.GetValue() * 10000.0
	float degraTimes = EABDegradationTimes.GetValue()
	int degraPoint = degraNum as int
	
	if (PA)
		degraPoint = (degraNum * degraTimes) as int
	endif
	
	float NowHealth = WornObject.GetItemHealthPercent(act, 0, eqslot[index])
	;self.log("NowHealth="+NowHealth)
	if (GetSwdFlag(NowHealth) == 0 || GetSwdFlag(NowHealth) == 4 || GetSwdFlag(NowHealth) == 8)
		if (GetSwdHealth(NowHealth) != 0)
			NowHealth = SetSwdFlag(NowHealth, 2)
			;self.log("obt@ݒς݂Ȃ̂ŃtOZbg")
		else
			NowHealth = SetSwdHealth(NowHealth, 990)
			NowHealth = SetSwdFlag(NowHealth, 2)
			;self.log("obt@")
		endif
	endif
	int CurrentSwdHealth = GetSwdHealth(NowHealth)
	int iwork = (NowHealth * 10.0) as int
	iwork *= 10000

	int NewSwdHealth = (CurrentSwdHealth + iwork) - degraPoint
	if (NewSwdHealth < 100000)
		float fwork = SetSwdFlag(1.0, 2)
		int rndswd = PO3_SKSEfunctions.GenerateRandomInt(0, 990)
		fwork = SetSwdHealth(fwork, rndswd)
		WornObject.SetItemHealthPercent(act, 0, eqslot[index], fwork)
		if (EABNoBreakList.Find(Item) != -1)
			return 0
		endif
		;item break
		return 2 ;ꂽ
	endif
	;degradation
	float updateHealth = (((NewSwdHealth / 10000.0) as int) / 10.0) as float
	int swdhealth = CurrentSwdHealth - degraPoint
	if (swdHealth < 0)
		swdHealth += 1000
	endif
	updateHealth = SetSwdHealth(updateHealth, (swdHealth))
	updateHealth = SetSwdFlag(updateHealth, 2)
	WornObject.SetItemHealthPercent(act, 0, eqslot[index], updateHealth)

	int degrade = (NowHealth * 10.0) as int - (updateHealth * 10.0) as int
	if degrade != 0
		return 1 ;1iK
	else
		return 0 ;healtĥ
	endif
EndFunction

int Function GetSwdFlag(float Health)
	string swork = Health as string
	string sflag = StringUtil.Substring(swork, 7, 1)
	int flag = sflag as int
	;debug.notification("getflg:"+Health+", "+flag)
	return flag
EndFunction

int Function GetSwdHealth(float Health)
	string swork = Health as string
	string shealth = StringUtil.Substring(swork,4, 3)
	int ret = shealth as int
	return ret
EndFunction

float Function SetSwdHealth(float Health, int SwdHealth)
	int flag = GetSwdFlag(Health)
	string swork = Health as string
	string shealthA = StringUtil.Substring(swork,0, 4)
	string shealthB
	if (SwdHealth < 10)
		shealthB = "00" + SwdHealth as string
	elseif (SwdHealth < 100)
		shealthB = "0" + SwdHealth as string
	else
		shealthB = SwdHealth as string
	endif
	string snewhealth = shealthA + shealthB + flag as string
	float ret = snewhealth as float
	return ret
EndFunction

float Function SetSwdFlag(float Health, int Flag)
	string swork = Health as string
	string shealth = StringUtil.Substring(swork,0, 7) + Flag as string
	float ret = shealth as float
	
	return ret
EndFunction

Function PlayFx(form Item)
	if (EABFxEnableNPC.GetValue() == 1)
		int BreakFx
		float volume = EABFxVolume.GetValue() as float
		int WeightClass = (Item as Armor).GetWeightClass()
		if (WeightClass == 0)
			BreakFx = EAB_FxLight.Play(targ)
		elseif (WeightClass == 1)
			BreakFx = EAB_FxHeavy.Play(targ)
		elseif (WeightClass == 2)
			BreakFx = EAB_FxClothe.Play(targ)
		endif
		Sound.SetInstanceVolume(BreakFx, volume)
	endif
EndFunction

form[] function GetEeuippedArmors(Actor act)
	Form[] retForm = new Form[32]
	Form[] EQArmor = new Form[32]
	Form[] formP0 = new Form[32]
	Form[] formP1 = new Form[32]
	Form[] formP2 = new Form[32]
	Form[] formP3 = new Form[32]
	Form[] formP4 = new Form[32]
	Form[] formP5 = new Form[32]
	Form[] formP6 = new Form[32]
	Form[] formP7 = new Form[32]
	Form[] formSP = new Form[32]
	int[] prio = new int[32]
	int[] Altprio = new int[32]
	eqslot = new int[32]
	int[] eqslotP0 = new int[32]
	int[] eqslotP1 = new int[32]
	int[] eqslotP2 = new int[32]
	int[] eqslotP3 = new int[32]
	int[] eqslotP4 = new int[32]
	int[] eqslotP5 = new int[32]
	int[] eqslotP6 = new int[32]
	int[] eqslotP7 = new int[32]
	int[] eqslotSP = new int[32]
	
    Int CurrentArmorSlotsMaskB = Math.LeftShift(EABSlotMaskB.GetValue() As Int, 24)
	Int CurrentArmorSlotsMaskA = EABSlotMask.GetValue() As Int
	int slotsChecked = Math.LogicalOr(CurrentArmorSlotsMaskA, CurrentArmorSlotsMaskB)
	
	int thisSlot = 0x01
	int pridx = 0
	int SC = 0x00
	int idx = 0
	int[] p = new int[9]
	int MinPriority = 9
	int pwork
	int ct = 0

	if (EABswdInstalled.GetValue() == 1)
		slotsChecked = Math.LogicalAnd(slotsChecked, 0xfffffdff)
	endif

	EQArmor = PO3_SKSEfunctions.AddAllEquippedItemsToArray(act)
	int EQcount = EQArmor.Length
	;debug.notification("EQcount="+EQcount)
	if EQcount == 0
		return none
	endif
	
	
	if (EABPriorityMode.GetValue() == 0)
		while (ct < EQcount)
			Armor thisArmor = EQArmor[ct] as Armor
			if (thisArmor && !thisArmor.HasKeywordString("SexLabNoStrip"))
				int slotmask = thisArmor.GetSlotMask()
				int slotmaskb = Math.LogicalAnd(slotsChecked, slotmask)
				if ((slotmaskb != 0x00) && (slotmask == slotmaskb))
					retForm[idx] = thisArmor
					eqslot[idx] = slotmask
					idx += 1
				endif
			endif
			ct += 1
		endWhile
		if idx == 0
			return none
		endif
		return retForm
	else
		; for Priority Mode
		prio = GetPriorityData()
		if (EABAltPriorityMode.GetValue() == 1)
			Altprio = GetAltPriorityData()
			
			int equippedMask = 0
			while (ct < EQCount)
				Armor thisArmor = EQArmor[ct] as Armor
				if (thisArmor)
					thisSlot = thisArmor.GetSlotMask()
					equippedMask = Math.LogicalOr(equippedMask, thisSlot)
				endif
				ct += 1
			endWhile
			
			ct = 0
			int ckmask
			while (ct < 32)
				if (Altprio[ct] != 29)
					int bitnum = Altprio[ct] - 30
					ckmask = Math.LeftShift(0x01,bitnum) 
					if (Math.LogicalAnd(equippedMask, ckmask) == 0)
						prio[ct] = prio[Altprio[ct]]
					endif
				endif
				ct += 1
			endWhile
		endif
		pridx = 0
		while pridx < MinPriority 
			p[pridx] = 0
			pridx += 1
		EndWhile
		pridx = 0
		ct = 0
		while (ct < EQcount)
			Armor thisArmor = EQArmor[ct] as Armor
			if (thisArmor && !thisArmor.HasKeywordString("SexLabNoStrip"))
				thisSlot = thisArmor.GetSlotMask()
				int slotmaskb = Math.LogicalAnd(slotsChecked, thisSlot)
				if ((slotmaskb != 0x00) && (thisSlot == slotmaskb))
					pridx = GetBitNum(thisSlot)
					pwork = p[prio[pridx]]
					if (thisArmor.HasKeywordString("EABPriorityLow"))
						formSP[p[8]] = thisArmor
						pwork = p[8]
						eqslotSP[pwork] = thisSlot
						p[8] = p[8] + 1
						if (MinPriority > 8)
							MinPriority = 8
						endif
					else
						if (prio[pridx] == 0)
							formP0[pwork] = thisArmor
							eqslotP0[pwork] = thisSlot
						elseif (prio[pridx] == 1)
							formP1[pwork] = thisArmor
							eqslotP1[pwork] = thisSlot
						elseif (prio[pridx] == 2)
							formP2[pwork] = thisArmor
							eqslotP2[pwork] = thisSlot
						elseif (prio[pridx] == 3)
							formP3[pwork] = thisArmor
							eqslotP3[pwork] = thisSlot
						elseif (prio[pridx] == 4)
							formP4[pwork] = thisArmor
							eqslotP4[pwork] = thisSlot
						elseif (prio[pridx] == 5)
							formP5[pwork] = thisArmor
							eqslotP5[pwork] = thisSlot
						elseif (prio[pridx] == 6)
							formP6[pwork] = thisArmor
							eqslotP6[pwork] = thisSlot
						elseif (prio[pridx] == 7)
							formP7[pwork] = thisArmor
							eqslotP7[pwork] = thisSlot
						endif
						if (MinPriority > prio[pridx])
							MinPriority = prio[pridx]
						endif
						p[prio[pridx]] = p[prio[pridx]] + 1
					endif
				endif
			endif
			ct += 1
		endWhile
		
		if (MinPriority == 0)
			eqslot = eqslotP0
			return formP0
		elseif (MinPriority == 1)
			eqslot = eqslotP1
			return formP1
		elseif (MinPriority == 2)
			eqslot = eqslotP2
			return formP2
		elseif (MinPriority == 3)
			eqslot = eqslotP3
			return formP3
		elseif (MinPriority == 4)
			eqslot = eqslotP4
			return formP4
		elseif (MinPriority == 5)
			eqslot = eqslotP5
			return formP5
		elseif (MinPriority == 6)
			eqslot = eqslotP6
			return formP6
		elseif (MinPriority == 7)
			eqslot = eqslotP7
			return formP7
		elseif (MinPriority == 8)
			eqslot = eqslotSP
			return formSP
		endif
	endif
	return none
EndFunction
int[] Function GetPriorityData()
	int[] Priority = new int[32]
	int count = 0
	int ct = 0
	int index = 0
	int[] priwork = new int[4]
	priwork[0] = EABPriority1.GetValue() as int
	priwork[1] = EABPriority2.GetValue() as int
	priwork[2] = EABPriority3.GetValue() as int
	priwork[3] = EABPriority4.GetValue() as int
	
	while ct < 4
		count = 0
		while count < 8
			Priority[index] = Math.LogicalAnd(Math.RightShift(priwork[ct],3*count), 0x00000007)
			index += 1
			count += 1
		EndWhile
		ct += 1
	EndWhile
	return priority
EndFunction
int[] Function GetAltPriorityData()
	int[] Priority = new int[32]
	int count = 0
	int ct = 0
	int index = 0
	int[] priwork = new int[8]
	priwork[0] = EABAltPriority1.GetValue() as int
	priwork[1] = EABAltPriority2.GetValue() as int
	priwork[2] = EABAltPriority3.GetValue() as int
	priwork[3] = EABAltPriority4.GetValue() as int
	priwork[4] = EABAltPriority5.GetValue() as int
	priwork[5] = EABAltPriority6.GetValue() as int
	priwork[6] = EABAltPriority7.GetValue() as int
	priwork[7] = EABAltPriority8.GetValue() as int
	
	while ct < 8
		count = 0
		while count < 4
			Priority[index] = Math.LogicalAnd(Math.RightShift(priwork[ct],6*count), 0x0000003f)
			index += 1
			count += 1
		EndWhile
		ct += 1
	EndWhile
	return priority
EndFunction
int Function GetBitNum(int slotmask)
	int idx = 0
	int lp = 0x01
	int check
	
	while (lp < 0x80000000)
		check = Math.LogicalAnd(slotmask, lp)
		if (check != 0x00)
			return idx
		endif
		lp *= 2
		idx += 1
	endWhile
EndFunction

GlobalVariable Property EABLogMode  Auto  
GlobalVariable Property EABBreakMode  Auto  
GlobalVariable Property EABRate  Auto  
GlobalVariable Property EABRatePA  Auto  
GlobalVariable Property EABSlotMask  Auto  
GlobalVariable Property EABSlotMaskB  Auto  
GlobalVariable Property EABEnchProtect  Auto  
GlobalVariable Property EABDegradationMode  Auto  
GlobalVariable Property EABNPCBreakMode  Auto  
GlobalVariable Property EABUnblockMode  Auto  
GlobalVariable Property EABPriorityMode auto
GlobalVariable Property EABPriority1 auto
GlobalVariable Property EABPriority2 auto
GlobalVariable Property EABPriority3 auto
GlobalVariable Property EABPriority4 auto
;EABInit Property EcchinaArmorBreak Auto
GlobalVariable Property EABAltPriorityMode auto
GlobalVariable Property EABAltPriority1 auto
GlobalVariable Property EABAltPriority2 auto
GlobalVariable Property EABAltPriority3 auto
GlobalVariable Property EABAltPriority4 auto
GlobalVariable Property EABAltPriority5 auto
GlobalVariable Property EABAltPriority6 auto
GlobalVariable Property EABAltPriority7 auto
GlobalVariable Property EABAltPriority8 auto
GlobalVariable Property EABNpcEnable auto
GlobalVariable Property EABNPCSex auto
GlobalVariable Property EABDegradationNum auto
GlobalVariable Property EABDegradationTimes auto
GlobalVariable Property EABswdInstalled Auto  
GlobalVariable Property EABswdBrokenMode auto
GlobalVariable Property EABEquipInterval auto
GlobalVariable Property EABReEquipMode auto
GlobalVariable Property EABFxEnableNPC auto
GlobalVariable Property EABFxVolume auto
FormList Property EABNoBreakList auto
Sound Property EAB_fxClothe Auto
Sound Property EAB_fxLight Auto
Sound Property EAB_fxHeavy Auto
