Scriptname EABMCMScript extends ski_configbase

;#########################
;New Baka Variables
;#########################

bool bSkimpyToggleDeathMode = true
bool bToggleDeathMode = true
bool bToggleSkimpyDeathMode = true
bool bToggleSkimpyArmorMissingMode = true

GlobalVariable Property EABPlayerTempArmorMissing auto
GlobalVariable Property EABPlayerTempArmorMissingChance auto
GlobalVariable Property EABDeathMode auto
GlobalVariable Property EABSkimpyDeathMode auto
GlobalVariable Property BaboSexlabArousedGlobal auto

int SliderMissingArmorRateID
int ToggleDeathModeID
int ToggleSkimpyDeathModeID
int ToggleSkimpyArmorMissingModeID

float fMissingArmorRate

Bool Property SexlabAroused_Installed Auto

Function VerifyMods()

	If Quest.Getquest("sla_Config")
		SexlabAroused_Installed = true
		BaboSexlabArousedGlobal.setvalue(1)
	Else
		SexlabAroused_Installed = false
		BaboSexlabArousedGlobal.setvalue(0)
	Endif

EndFunction


;#########################
;#########################
;#########################

GlobalVariable Property EABLogMode  Auto  
GlobalVariable Property EABBreakMode auto
GlobalVariable Property EABRate auto
GlobalVariable Property EABRatePA auto
GlobalVariable Property EABSlotMask auto
GlobalVariable Property EABSlotMaskB auto
GlobalVariable Property EABEnchProtect auto
GlobalVariable Property EABFollowerMode auto
GlobalVariable Property EABDegradationMode auto
GlobalVariable Property EABDegradationNum auto
GlobalVariable Property EABDegradationTimes auto
GlobalVariable Property EABFollowerBreakMode auto
GlobalVariable Property EABNpcBreakMode auto
GlobalVariable Property EABUnblockMode auto
GlobalVariable Property EABPriorityMode auto
GlobalVariable Property EABPriority1 auto
GlobalVariable Property EABPriority2 auto
GlobalVariable Property EABPriority3 auto
GlobalVariable Property EABPriority4 auto
GlobalVariable Property EABPlayerInterval auto
GlobalVariable Property EABFollowerInterval auto
GlobalVariable Property EABAltPriorityMode auto
GlobalVariable Property EABAltPriority1 auto
GlobalVariable Property EABAltPriority2 auto
GlobalVariable Property EABAltPriority3 auto
GlobalVariable Property EABAltPriority4 auto
GlobalVariable Property EABAltPriority5 auto
GlobalVariable Property EABAltPriority6 auto
GlobalVariable Property EABAltPriority7 auto
GlobalVariable Property EABAltPriority8 auto
GlobalVariable Property EABFollowerSex auto
GlobalVariable Property EABNpcSex auto
GlobalVariable Property EABLostTimeMode  Auto  
GlobalVariable Property EABLostTimeInterval  Auto  
GlobalVariable Property EABStolen auto
GlobalVariable Property EABswdBrokenMode auto
GlobalVariable Property EABNpcEnable auto
GlobalVariable Property EABReEquipMode auto
GlobalVariable Property EABEquipInterval auto
GlobalVariable Property EABFReEquipMode auto
GlobalVariable Property EABFEquipInterval auto
GlobalVariable Property EABFxEnable auto
GlobalVariable Property EABFxEnableFollower auto
GlobalVariable Property EABFxEnableNPC auto
GlobalVariable Property EABFxVolume auto
;ϐ̒?
int SliderBreakModeID
int ToggleLogModeID
int ToggleLostTimeModeID
int ToggleEnchProtectID
int SliderRateID
int SliderRatePAID
int[] ToggleSlotID
int[] SliderPriorityID
int[] SliderAltPriorityID
int ToggleFollowerModeID
int ToggleDegradationModeID
int SliderFollowerBreakModeID
int SliderNpcBreakModeID
int ToggleUnblockModeID
int TogglePriorityModeID
int ToggleAltPriorityModeID
int SliderPlayerIntervalID
int SliderFollowerIntervalID
int SliderFollowerSexID
int SliderNpcSexID
int SliderLostTimeIntervalID
int SliderDegradationNumID
int SliderDegradationTimesID
int SliderStolenID
int ToggleSwdBrokenModeID
int ToggleNpcEnableID
int SliderEquipIntervalID
int ToggleReEquipModeID
int SliderFEquipIntervalID
int ToggleFReEquipModeID
int ToggleFxEnableID
int ToggleFxEnableFollowerID
int ToggleFxEnableNPCID
int SliderFxVolumeID


float fSliderBreakMode
bool bToggleLogMode
bool bToggleLostTimeMode
bool bToggleEnchProtect
float fSliderRate
float fSliderRatePA
float fSliderLostTimeInterval
bool[] bToggleSlot
float[] fSliderPriority
float[] fSliderAltPriority
bool bToggleUnblockMode
bool bTogglePriorityMode
bool bToggleAltPriorityMode
bool bToggleFollowerMode
bool bToggleDegradationMode
float fSliderFollowerBreakMode
float fSliderNpcBreakMode
float fSliderPlayerInterval
float fSliderFollowerInterval
float fSliderFollowerSex
float fSliderNpcSex
float fSliderDegradationNum
float fSliderDegradationTimes
float fSliderStolen
bool bToggleSwdBrokenMode
bool bToggleNpcEnable
float fSliderEquipInterval
bool bToggleReEquipMode
float fSliderFEquipInterval
bool bToggleFReEquipMode
bool bToggleFxEnable
bool bToggleFxEnableFollower
bool bToggleFxEnableNPC
float fSliderFxVolume

String[] Pages
int function GetVersion()
	return 13
endFunction

; 
Event OnConfigInit()
	Pages = New String[3]
	Pages[0] = "Basic Settings"
	Pages[1] = "Priorities"
	Pages[2] = "AltPriorities"
	
    ToggleSlotID = new int[32]
    bToggleSlot = new Bool[32]
    SliderPriorityID = new int[32]
    fSliderPriority = new float[32]
    SliderAltPriorityID = new int[32]
    fSliderAltPriority = new float[32]
	
	VerifyMods()
EndEvent

;y?W̐ݒ
Event OnPageReset(string page)
   if (page == "" || page == "Basic Settings" )
	   SetCursorFillMode(TOP_TO_BOTTOM)
	   AddHeaderOption("Settings")
	   
	   fSliderBreakMode = EABBreakMode.GetValue()
	   SliderBreakModeID = AddSliderOption("Armor Break Mod", fSliderBreakMode, "{0}")
	   
	   fSliderRate = EABRate.GetValue()
	   SliderRateID = AddSliderOption("Chance(Normal Attack)", fSliderRate, "{1}%")

	   fSliderRatePA = EABRatePA.GetValue()
	   SliderRatePAID = AddSliderOption("Chance(Power Attack)", fSliderRatePA, "{1}%")

	   fSliderStolen = EABStolen.GetValue()
	   SliderStolenID = AddSliderOption("Chance to get stolen", fSliderStolen, "{1}%")

	   bToggleUnblockMode = EABUnblockMode.GetValue() as bool
	   ToggleUnblockModeID = AddToggleOption("Ineffective Blocking", bToggleUnblockMode)

	   bToggleEnchProtect = EABEnchProtect.GetValue() As Bool
	   ToggleEnchProtectID = AddToggleOption("Protect Enchanted Armor", bToggleEnchProtect)
	   
	   bToggleFxEnable = EABFxEnable.GetValue() as bool
	   ToggleFxEnableID = AddToggleOption("Armor Break Sound Effect(Player)", bToggleFxEnable)
	   
	   fSliderFxVolume = EABFxVolume.GetValue()
	   SliderFxVolumeID = AddSliderOption("Sound Volume", fSliderFxVolume, "{1}")
	   
		ToggleDeathModeID = AddToggleOption("Drop Armors on Death", bToggleDeathMode)
		ToggleSkimpyDeathModeID = AddToggleOption("Only Skimpy on Death", bToggleSkimpyDeathMode)
		ToggleSkimpyArmorMissingModeID = AddToggleOption("Temporal Break", bToggleSkimpyArmorMissingMode)
		SliderMissingArmorRateID = AddSliderOption("Possibility", fMissingArmorRate, "{1}%")
	   
	   AddHeaderOption("Degradation Settings")

	   bToggleDegradationMode = EABDegradationMode.GetValue() As Bool
	   ToggleDegradationModeID = AddToggleOption("Simple Degradation", bToggleDegradationMode)
	   
	   fSliderDegradationNum = EABDegradationNum.GetValue()
	   SliderDegradationNumID = AddSliderOption("Degradation Speed", fSliderDegradationNum, "{3}")
	   
	   fSliderDegradationTimes = EABDegradationTimes.GetValue()
	   SliderDegradationTimesID = AddSliderOption("Degradation Speed(Power Attack)", fSliderDegradationTimes, "{2}")
	   
	   bToggleSwdBrokenMode = EABswdBrokenMode.GetValue()
       ToggleSwdBrokenModeID = AddToggleOption("Mending Broken", bToggleSwdBrokenMode)

	   AddHeaderOption("Equipment Penalty Features")

	   bToggleLostTimeMode = EABLostTimeMode.GetValue() As Bool
	   ToggleLostTimeModeID = AddToggleOption("Reequipment Penalty", bToggleLostTimeMode)

	   fSliderLostTimeInterval = EABLostTimeInterval.GetValue()
	   SliderLostTimeIntervalID = AddSliderOption("Reequipment Penalty Time Interval", fSliderLostTimeInterval, "{0}Minutes")

	   AddHeaderOption("Follower Settings")

	   bToggleFollowerMode = EABFollowerMode.GetValue() As Bool
	   ToggleFollowerModeID = AddToggleOption("Activate Followers", bToggleFollowerMode)

	   fSliderFollowerBreakMode = EABFollowerBreakMode.GetValue()
	   SliderFollowerBreakModeID = AddSliderOption("Follower Armor Break", fSliderFollowerBreakMode, "{0}")

	   fSliderFollowerSex = EABFollowerSex.GetValue()
	   SliderFollowerSexID = AddSliderOption("Follower's Sex", fSliderFollowerSex, "{0}")

	   bToggleFReEquipMode = EABFReEquipMode.GetValue() as bool
	   ToggleFReEquipModeID = AddToggleOption("Allow Reuse Unequipped", bToggleFReEquipMode)

	   fSliderFEquipInterval = EABFEquipInterval.GetValue()
	   SliderFEquipIntervalID = AddSliderOption("Allow Reuse Time Interval", fSliderFEquipInterval, "{2}")

	   bToggleFxEnableFollower = EABFxEnableFollower.GetValue() as bool
	   ToggleFxEnableFollowerID = AddToggleOption("Armor Break Sound Effect", bToggleFxEnableFollower)
	   
	   AddHeaderOption("NPC Settings")

	   bToggleNpcEnable = EABNpcEnable.GetValue() As Bool
	   ToggleNpcEnableID = AddToggleOption("Activate NPC", bToggleNpcEnable)
	   
	   fSliderNpcBreakMode = EABNpcBreakMode.GetValue()
	   SliderNpcBreakModeID = AddSliderOption("NPC Armor Break", fSliderNpcBreakMode, "{0}")

	   fSliderNpcSex = EABNpcSex.GetValue()
	   SliderNpcSexID = AddSliderOption("NPC Sex", fSliderNpcSex, "{0}")

	   bToggleReEquipMode = EABReEquipMode.GetValue() as bool
	   ToggleReEquipModeID = AddToggleOption("Allow Reuse Unequipped", bToggleReEquipMode)

	   fSliderEquipInterval = EABEquipInterval.GetValue()
	   SliderEquipIntervalID = AddSliderOption("Allow Reuse Time Interval", fSliderEquipInterval, "{2}")
	   
	   bToggleFxEnableNPC = EABFxEnableNPC.GetValue() as bool
	   ToggleFxEnableNPCID = AddToggleOption("Armor Break Sound Effect", bToggleFxEnableNPC)
	   
	   AddHeaderOption("Misc Settings")
	   
	   fSliderPlayerInterval = EABPlayerInterval.GetValue()
	   SliderPlayerIntervalID = AddSliderOption("Player Interval", fSliderPlayerInterval, "{1}b")

	   fSliderFollowerInterval = EABFollowerInterval.GetValue()
	   SliderFollowerIntervalID = AddSliderOption("Follower Interval", fSliderFollowerInterval, "{1}b")

	   bToggleLogMode = EABLogMode.GetValue() As Bool
	   ToggleLogModeID = AddToggleOption("Toggle Log Message", bToggleLogMode)

	   SetCursorPosition(1)
	   bToggleSlot = GetUnignoredArmorSlots(EABSlotMask, EABSlotMaskB)
	   
	   AddHeaderOption("Strip Armor List")
	   ToggleSlotID[0] = AddToggleOption("30 - Head", bToggleSlot[0])
	   ToggleSlotID[1] = AddToggleOption("31 - Hair", bToggleSlot[1])
	   ToggleSlotID[2] = AddToggleOption("32 - Body", bToggleSlot[2])
	   ToggleSlotID[3] = AddToggleOption("33 - Hands", bToggleSlot[3])
	   ToggleSlotID[4] = AddToggleOption("34 - Forearms", bToggleSlot[4])
	   ToggleSlotID[5] = AddToggleOption("35 - Amulet", bToggleSlot[5])
	   ToggleSlotID[6] = AddToggleOption("36 - Ring", bToggleSlot[6])
	   ToggleSlotID[7] = AddToggleOption("37 - Feet", bToggleSlot[7])
	   ToggleSlotID[8] = AddToggleOption("38 - Calves", bToggleSlot[8])
	   if Game.GetModByName("SimpleWeaponDegrade.esp") < 255
	       bToggleSlot[9] = 0
           ToggleSlotID[9] = AddToggleOption("39 - Shield", bToggleSlot[9], OPTION_FLAG_DISABLED)
	   else
           ToggleSlotID[9] = AddToggleOption("39 - Shield", bToggleSlot[9])
       endif
	   ToggleSlotID[10] = AddToggleOption("40 - Tail", bToggleSlot[10])
	   ToggleSlotID[11] = AddToggleOption("41 - LongHair", bToggleSlot[11])
	   ToggleSlotID[12] = AddToggleOption("42 - Circlet", bToggleSlot[12])
	   ToggleSlotID[13] = AddToggleOption("43 - Ears", bToggleSlot[13])
	   ToggleSlotID[14] = AddToggleOption("44 - Unnamed", bToggleSlot[14])
	   ToggleSlotID[15] = AddToggleOption("45 - Unnamed", bToggleSlot[15])
	   ToggleSlotID[16] = AddToggleOption("46 - Unnamed", bToggleSlot[16])
	   ToggleSlotID[17] = AddToggleOption("47 - Unnamed", bToggleSlot[17])
	   ToggleSlotID[18] = AddToggleOption("48 - Unnamed", bToggleSlot[18])
	   ToggleSlotID[19] = AddToggleOption("49 - Unnamed", bToggleSlot[19])
	   ToggleSlotID[20] = AddToggleOption("50 - DecapitateHead", bToggleSlot[20])
	   ToggleSlotID[21] = AddToggleOption("51 - Decapitate", bToggleSlot[21])
	   ToggleSlotID[22] = AddToggleOption("52 - Unnamed", bToggleSlot[22])
	   ToggleSlotID[23] = AddToggleOption("53 - Unnamed", bToggleSlot[23])
	   ToggleSlotID[24] = AddToggleOption("54 - Unnamed", bToggleSlot[24])
	   ToggleSlotID[25] = AddToggleOption("55 - Unnamed", bToggleSlot[25])
	   ToggleSlotID[26] = AddToggleOption("56 - Unnamed", bToggleSlot[26])
	   ToggleSlotID[27] = AddToggleOption("57 - Unnamed", bToggleSlot[27])
	   ToggleSlotID[28] = AddToggleOption("58 - Unnamed", bToggleSlot[28])
	   ToggleSlotID[29] = AddToggleOption("59 - Unnamed", bToggleSlot[29])
	   ToggleSlotID[30] = AddToggleOption("60 - Unnamed", bToggleSlot[30])
	   ToggleSlotID[31] = AddToggleOption("61 - FX01", bToggleSlot[31])
   elseif (page =="Priorities" )
	   SetCursorFillMode(TOP_TO_BOTTOM)
	   AddHeaderOption("Priorities")

	   GTPriority()
	   bTogglePriorityMode = EABPriorityMode.GetValue() As Bool
	   TogglePriorityModeID = AddToggleOption("Priority Setting", bTogglePriorityMode)

	   AddHeaderOption("Armor Slot Priorities")
	   SliderPriorityID[0] = AddSliderOption("30 - Head", fSliderPriority[0], "{0}")
	   SliderPriorityID[1] = AddSliderOption("31 - Hair", fSliderPriority[1], "{0}")
	   SliderPriorityID[2] = AddSliderOption("32 - Body", fSliderPriority[2], "{0}")
	   SliderPriorityID[3] = AddSliderOption("33 - Hands", fSliderPriority[3], "{0}")
	   SliderPriorityID[4] = AddSliderOption("34 - Forearms", fSliderPriority[4], "{0}")
	   SliderPriorityID[5] = AddSliderOption("35 - Amulet", fSliderPriority[5], "{0}")
	   SliderPriorityID[6] = AddSliderOption("36 - Ring", fSliderPriority[6], "{0}")
	   SliderPriorityID[7] = AddSliderOption("37 - Feet", fSliderPriority[7], "{0}")
	   SliderPriorityID[8] = AddSliderOption("38 - Calves", fSliderPriority[8], "{0}")
	   SliderPriorityID[9] = AddSliderOption("39 - Shield", fSliderPriority[9], "{0}")
	   SliderPriorityID[10] = AddSliderOption("40 - Tail", fSliderPriority[10], "{0}")
	   SliderPriorityID[11] = AddSliderOption("41 - LongHair", fSliderPriority[11], "{0}")
	   SliderPriorityID[12] = AddSliderOption("42 - Circlet", fSliderPriority[12], "{0}")
	   SliderPriorityID[13] = AddSliderOption("43 - Ears", fSliderPriority[13], "{0}")
	   SliderPriorityID[14] = AddSliderOption("44 - Unnamed", fSliderPriority[14], "{0}")
	   SliderPriorityID[15] = AddSliderOption("45 - Unnamed", fSliderPriority[15], "{0}")
	   
	   SetCursorPosition(5)
	   AddHeaderOption("")
	   SetCursorPosition(7)
	   SliderPriorityID[16] = AddSliderOption("46 - Unnamed", fSliderPriority[16], "{0}")
	   SliderPriorityID[17] = AddSliderOption("47 - Unnamed", fSliderPriority[17], "{0}")
	   SliderPriorityID[18] = AddSliderOption("48 - Unnamed", fSliderPriority[18], "{0}")
	   SliderPriorityID[19] = AddSliderOption("49 - Unnamed", fSliderPriority[19], "{0}")
	   SliderPriorityID[20] = AddSliderOption("50 - DecapitateHead", fSliderPriority[20], "{0}")
	   SliderPriorityID[21] = AddSliderOption("51 - Decapitate", fSliderPriority[21], "{0}")
	   SliderPriorityID[22] = AddSliderOption("52 - Unnamed", fSliderPriority[22], "{0}")
	   SliderPriorityID[23] = AddSliderOption("53 - Unnamed", fSliderPriority[23], "{0}")
	   SliderPriorityID[24] = AddSliderOption("54 - Unnamed", fSliderPriority[24], "{0}")
	   SliderPriorityID[25] = AddSliderOption("55 - Unnamed", fSliderPriority[25], "{0}")
	   SliderPriorityID[26] = AddSliderOption("56 - Unnamed", fSliderPriority[26], "{0}")
	   SliderPriorityID[27] = AddSliderOption("57 - Unnamed", fSliderPriority[27], "{0}")
	   SliderPriorityID[28] = AddSliderOption("58 - Unnamed", fSliderPriority[28], "{0}")
	   SliderPriorityID[29] = AddSliderOption("59 - Unnamed", fSliderPriority[29], "{0}")
	   SliderPriorityID[30] = AddSliderOption("60 - Unnamed", fSliderPriority[30], "{0}")
	   SliderPriorityID[31] = AddSliderOption("61 - FX01", fSliderPriority[31], "{0}")
	   
   elseif (page =="AltPriorities" )
	   SetCursorFillMode(TOP_TO_BOTTOM)
	   AddHeaderOption("AltPriorities")

	   GTAltPriority()
	   bToggleAltPriorityMode = EABAltPriorityMode.GetValue() As Bool
	   ToggleAltPriorityModeID = AddToggleOption("Alternative Priorities", bToggleAltPriorityMode)

	   AddHeaderOption("Armor Slot Alt Priorities")
	   SliderAltPriorityID[0] = AddSliderOption("30 - Head", fSliderAltPriority[0], "{0}")
	   SliderAltPriorityID[1] = AddSliderOption("31 - Hair", fSliderAltPriority[1], "{0}")
	   SliderAltPriorityID[2] = AddSliderOption("32 - Body", fSliderAltPriority[2], "{0}")
	   SliderAltPriorityID[3] = AddSliderOption("33 - Hands", fSliderAltPriority[3], "{0}")
	   SliderAltPriorityID[4] = AddSliderOption("34 - Forearms", fSliderAltPriority[4], "{0}")
	   SliderAltPriorityID[5] = AddSliderOption("35 - Amulet", fSliderAltPriority[5], "{0}")
	   SliderAltPriorityID[6] = AddSliderOption("36 - Ring", fSliderAltPriority[6], "{0}")
	   SliderAltPriorityID[7] = AddSliderOption("37 - Feet", fSliderAltPriority[7], "{0}")
	   SliderAltPriorityID[8] = AddSliderOption("38 - Calves", fSliderAltPriority[8], "{0}")
	   SliderAltPriorityID[9] = AddSliderOption("39 - Shield", fSliderAltPriority[9], "{0}")
	   SliderAltPriorityID[10] = AddSliderOption("40 - Tail", fSliderAltPriority[10], "{0}")
	   SliderAltPriorityID[11] = AddSliderOption("41 - LongHair", fSliderAltPriority[11], "{0}")
	   SliderAltPriorityID[12] = AddSliderOption("42 - Circlet", fSliderAltPriority[12], "{0}")
	   SliderAltPriorityID[13] = AddSliderOption("43 - Ears", fSliderAltPriority[13], "{0}")
	   SliderAltPriorityID[14] = AddSliderOption("44 - Unnamed", fSliderAltPriority[14], "{0}")
	   SliderAltPriorityID[15] = AddSliderOption("45 - Unnamed", fSliderAltPriority[15], "{0}")
	   
	   SetCursorPosition(5)
	   AddHeaderOption("")
	   SetCursorPosition(7)
	   SliderAltPriorityID[16] = AddSliderOption("46 - Unnamed", fSliderAltPriority[16], "{0}")
	   SliderAltPriorityID[17] = AddSliderOption("47 - Unnamed", fSliderAltPriority[17], "{0}")
	   SliderAltPriorityID[18] = AddSliderOption("48 - Unnamed", fSliderAltPriority[18], "{0}")
	   SliderAltPriorityID[19] = AddSliderOption("49 - Unnamed", fSliderAltPriority[19], "{0}")
	   SliderAltPriorityID[20] = AddSliderOption("50 - DecapitateHead", fSliderAltPriority[20], "{0}")
	   SliderAltPriorityID[21] = AddSliderOption("51 - Decapitate", fSliderAltPriority[21], "{0}")
	   SliderAltPriorityID[22] = AddSliderOption("52 - Unnamed", fSliderAltPriority[22], "{0}")
	   SliderAltPriorityID[23] = AddSliderOption("53 - Unnamed", fSliderAltPriority[23], "{0}")
	   SliderAltPriorityID[24] = AddSliderOption("54 - Unnamed", fSliderAltPriority[24], "{0}")
	   SliderAltPriorityID[25] = AddSliderOption("55 - Unnamed", fSliderAltPriority[25], "{0}")
	   SliderAltPriorityID[26] = AddSliderOption("56 - Unnamed", fSliderAltPriority[26], "{0}")
	   SliderAltPriorityID[27] = AddSliderOption("57 - Unnamed", fSliderAltPriority[27], "{0}")
	   SliderAltPriorityID[28] = AddSliderOption("58 - Unnamed", fSliderAltPriority[28], "{0}")
	   SliderAltPriorityID[29] = AddSliderOption("59 - Unnamed", fSliderAltPriority[29], "{0}")
	   SliderAltPriorityID[30] = AddSliderOption("60 - Unnamed", fSliderAltPriority[30], "{0}")
	   SliderAltPriorityID[31] = AddSliderOption("61 - FX01", fSliderAltPriority[31], "{0}")
	   
   endif
endEvent


Event OnOptionSelect(int option)
   if (option == ToggleLogModeID)
       bToggleLogMode = !bToggleLogMode
       SetToggleOptionValue(ToggleLogModeID, bToggleLogMode)
       If(bToggleLogMode)
         EABLogMode.SetValue(1)
       Else
         EABLogMode.SetValue(0)
       EndIf
   elseif (option == ToggleDeathModeID)
       bToggleDeathMode = !bToggleDeathMode
       SetToggleOptionValue(ToggleDeathModeID, bToggleDeathMode)
       If(bToggleDeathMode)
         EABDeathMode.SetValue(1)
       Else
         EABDeathMode.SetValue(0)
       EndIf
   elseif (option == ToggleSkimpyDeathModeID)
       bToggleSkimpyDeathMode = !bToggleSkimpyDeathMode
       SetToggleOptionValue(ToggleSkimpyDeathModeID, bToggleSkimpyDeathMode)
       If(bSkimpyToggleDeathMode)
         EABSkimpyDeathMode.SetValue(1)
       Else
         EABSkimpyDeathMode.SetValue(0)
       EndIf
   elseif (option == ToggleSkimpyArmorMissingModeID)
       bToggleSkimpyArmorMissingMode = !bToggleSkimpyArmorMissingMode
       SetToggleOptionValue(ToggleSkimpyArmorMissingModeID, bToggleSkimpyArmorMissingMode)
       If(bToggleSkimpyArmorMissingMode)
         EABPlayerTempArmorMissing.SetValue(1)
       Else
         EABPlayerTempArmorMissing.SetValue(0)
       EndIf
   elseif (option == ToggleLostTimeModeID)
       bToggleLostTimeMode = !bToggleLostTimeMode
       SetToggleOptionValue(ToggleLostTimeModeID, bToggleLostTimeMode)
       If(bToggleLostTimeMode)
         EABLostTimeMode.SetValue(1)
       Else
         EABLostTimeMode.SetValue(0)
       EndIf
   elseif (option == ToggleSwdBrokenModeID)
       bToggleSwdBrokenMode = !bToggleSwdBrokenMode
       SetToggleOptionValue(ToggleSwdBrokenModeID, bToggleSwdBrokenMode)
       If(bToggleSwdBrokenMode)
         EABswdBrokenMode.SetValue(1)
       Else
         EABswdBrokenMode.SetValue(0)
       EndIf
   elseif(option == ToggleEnchProtectID)
       bToggleEnchProtect = !bToggleEnchProtect
       SetToggleOptionValue(ToggleEnchProtectID, bToggleEnchProtect)
       If(bToggleEnchProtect)
         EABEnchProtect.SetValue(1)
       Else
         EABEnchProtect.SetValue(0)
       EndIf
   elseif (option == ToggleFollowerModeID)
       bToggleFollowerMode = !bToggleFollowerMode
       SetToggleOptionValue(ToggleFollowerModeID, bToggleFollowerMode)
       If(bToggleFollowerMode)
         EABFollowerMode.SetValue(1)
       Else
         EABFollowerMode.SetValue(0)
       EndIf
   elseif (option == ToggleDegradationModeID)
       bToggleDegradationMode = !bToggleDegradationMode
       SetToggleOptionValue(ToggleDegradationModeID, bToggleDegradationMode)
       If(bToggleDegradationMode)
         EABDegradationMode.SetValue(1)
       Else
         EABDegradationMode.SetValue(0)
       EndIf
   elseif (option == ToggleUnblockModeID)
       bToggleUnblockMode = !bToggleUnblockMode
       SetToggleOptionValue(ToggleUnblockModeID, bToggleUnblockMode)
       If(bToggleUnblockMode)
         EABUnblockMode.SetValue(1)
       Else
         EABUnblockMode.SetValue(0)
       EndIf
   elseif (option == TogglePriorityModeID)
       bTogglePriorityMode = !bTogglePriorityMode
       SetToggleOptionValue(TogglePriorityModeID, bTogglePriorityMode)
       If(bTogglePriorityMode)
         EABPriorityMode.SetValue(1)
       Else
         EABPriorityMode.SetValue(0)
       EndIf
   elseif (option == ToggleAltPriorityModeID)
       bToggleAltPriorityMode = !bToggleAltPriorityMode
       SetToggleOptionValue(ToggleAltPriorityModeID, bToggleAltPriorityMode)
       If(bToggleAltPriorityMode)
         EABAltPriorityMode.SetValue(1)
       Else
         EABAltPriorityMode.SetValue(0)
       EndIf
   elseif (option == ToggleNpcEnableID)
       bToggleNpcEnable = !bToggleNpcEnable
       SetToggleOptionValue(ToggleNpcEnableID, bToggleNpcEnable)
       If(bToggleNpcEnable)
         EABNpcEnable.SetValue(1)
       Else
         EABNpcEnable.SetValue(0)
       EndIf
   elseif (option == ToggleReEquipModeID)
       bToggleReEquipMode = !bToggleReEquipMode
       SetToggleOptionValue(ToggleReEquipModeID, bToggleReEquipMode)
       If(bToggleReEquipMode)
         EABReEquipMode.SetValue(1)
       Else
         EABReEquipMode.SetValue(0)
       EndIf
   elseif (option == ToggleFReEquipModeID)
       bToggleFReEquipMode = !bToggleFReEquipMode
       SetToggleOptionValue(ToggleFReEquipModeID, bToggleFReEquipMode)
       If(bToggleFReEquipMode)
         EABFReEquipMode.SetValue(1)
       Else
         EABFReEquipMode.SetValue(0)
       EndIf
   elseif (option == ToggleFxEnableID)
       bToggleFxEnable = !bToggleFxEnable
       SetToggleOptionValue(ToggleFxEnableID, bToggleFxEnable)
       If(bToggleFxEnable)
         EABFxEnable.SetValue(1)
       Else
         EABFxEnable.SetValue(0)
       EndIf
   elseif (option == ToggleFxEnableFollowerID)
       bToggleFxEnableFollower = !bToggleFxEnableFollower
       SetToggleOptionValue(ToggleFxEnableFollowerID, bToggleFxEnableFollower)
       If(bToggleFxEnableFollower)
         EABFxEnableFollower.SetValue(1)
       Else
         EABFxEnableFollower.SetValue(0)
       EndIf
   elseif (option == ToggleFxEnableNPCID)
       bToggleFxEnableNPC = !bToggleFxEnableNPC
       SetToggleOptionValue(ToggleFxEnableNPCID, bToggleFxEnableNPC)
       If(bToggleFxEnableNPC)
         EABFxEnableNPC.SetValue(1)
       Else
         EABFxEnableNPC.SetValue(0)
       EndIf
   else
       int idx = ToggleSlotID.Find(option)
       if (idx >= 0)
           bToggleSlot[idx] = !bToggleSlot[idx]
           IgnoreArmorSlot(EABSlotMask, EABSlotMaskB, idx + 30, !bToggleSlot[idx])
           SetToggleOptionValue(option, bToggleSlot[idx])
       endif
   endIf
endEvent

;XC??J̃CxgEݒ
Event OnOptionSliderOpen(int option)
   if (option == SliderRateID)
       SetSliderDialogStartValue(fSliderRate)
       SetSliderDialogDefaultValue(15)
       SetSliderDialogRange(0, 100)
       SetSliderDialogInterval(0.1)
   elseif (option == SliderMissingArmorRateID)
       SetSliderDialogStartValue(fMissingArmorRate)
       SetSliderDialogDefaultValue(10)
       SetSliderDialogRange(0, 100)
       SetSliderDialogInterval(1)
   elseif (option == SliderRatePAID)
       SetSliderDialogStartValue(fSliderRatePA)
       SetSliderDialogDefaultValue(80)
       SetSliderDialogRange(0, 100)
       SetSliderDialogInterval(0.1)
   elseif (option == SliderStolenID)
       SetSliderDialogStartValue(fSliderStolen)
       SetSliderDialogDefaultValue(5)
       SetSliderDialogRange(0, 100)
       SetSliderDialogInterval(0.1)
   elseif (option == SliderFollowerBreakModeID)
       SetSliderDialogStartValue(fSliderFollowerBreakMode)
       SetSliderDialogDefaultValue(0)
       SetSliderDialogRange(0, 3)
       SetSliderDialogInterval(1)
   elseif (option == SliderNpcBreakModeID)
       SetSliderDialogStartValue(fSliderNpcBreakMode)
       SetSliderDialogDefaultValue(0)
       SetSliderDialogRange(0, 3)
       SetSliderDialogInterval(1)
   elseif (option == SliderBreakModeID)
       SetSliderDialogStartValue(fSliderBreakMode)
       SetSliderDialogDefaultValue(0)
       SetSliderDialogRange(0, 3)
       SetSliderDialogInterval(1)
   elseif (option == SliderPlayerIntervalID)
       SetSliderDialogStartValue(fSliderPlayerInterval)
       SetSliderDialogDefaultValue(2)
       SetSliderDialogRange(0.5, 5)
       SetSliderDialogInterval(0.1)
   elseif (option == SliderFollowerIntervalID)
       SetSliderDialogStartValue(fSliderFollowerInterval)
       SetSliderDialogDefaultValue(2)
       SetSliderDialogRange(0.5, 5)
       SetSliderDialogInterval(0.1)
   elseif (option == SliderDegradationNumID)
       SetSliderDialogStartValue(fSliderDegradationNum)
       SetSliderDialogDefaultValue(0.100)
       SetSliderDialogRange(0.001, 0.100)
       SetSliderDialogInterval(0.005)
   elseif (option == SliderDegradationTimesID)
       SetSliderDialogStartValue(fSliderDegradationTimes)
       SetSliderDialogDefaultValue(1.00)
       SetSliderDialogRange(1.00, 10.00)
       SetSliderDialogInterval(0.25)
   elseif (option == SliderFollowerSexID)
       SetSliderDialogStartValue(fSliderFollowerSex)
       SetSliderDialogDefaultValue(2)
       SetSliderDialogRange(0, 2)
       SetSliderDialogInterval(1)
   elseif (option == SliderNpcSexID)
       SetSliderDialogStartValue(fSliderNpcSex)
       SetSliderDialogDefaultValue(2)
       SetSliderDialogRange(0, 2)
       SetSliderDialogInterval(1)
   elseif (option == SliderLostTimeIntervalID)
       SetSliderDialogStartValue(fSliderLostTimeInterval)
       SetSliderDialogDefaultValue(5)
       SetSliderDialogRange(1, 300)
       SetSliderDialogInterval(1)
   elseif (option == SliderEquipIntervalID)
       SetSliderDialogStartValue(fSliderEquipInterval)
       SetSliderDialogDefaultValue(0.25)
       SetSliderDialogRange(0.05, 1.0)
       SetSliderDialogInterval(0.05)
   elseif (option == SliderFEquipIntervalID)
       SetSliderDialogStartValue(fSliderFEquipInterval)
       SetSliderDialogDefaultValue(0.25)
       SetSliderDialogRange(0.05, 1.0)
       SetSliderDialogInterval(0.05)
   elseif (option == SliderFxVolumeID)
       SetSliderDialogStartValue(fSliderFxVolume)
       SetSliderDialogDefaultValue(1.0)
       SetSliderDialogRange(0.1, 1.0)
       SetSliderDialogInterval(0.10)
   else
       int idx = SliderPriorityID.Find(option)
       if (idx >= 0)
           SetSliderDialogStartValue(fSliderPriority[idx])
           SetSliderDialogDefaultValue(1)
           SetSliderDialogRange(1,8)
           SetSliderDialogInterval(1)
       endif

       idx = SliderAltPriorityID.Find(option)
       if (idx >= 0)
           SetSliderDialogStartValue(fSliderAltPriority[idx])
           SetSliderDialogDefaultValue(29)
           SetSliderDialogRange(29,61)
           SetSliderDialogInterval(1)
       endif
   endIf
EndEvent

Event OnOptionSliderAccept(int option, float value)
   if (option == SliderRateID)
       fSliderRate = value
       SetSliderOptionValue(SliderRateID, fSliderRate, "{1}%")
       EABRate.SetValue(fSliderRate)
   elseif (option == SliderMissingArmorRateID)
       fMissingArmorRate = value
       SetSliderOptionValue(SliderMissingArmorRateID, fMissingArmorRate, "{1}%")
       EABPlayerTempArmorMissingChance.SetValue(fMissingArmorRate)
   elseif (option == SliderRatePAID)
       fSliderRatePA = value
       SetSliderOptionValue(SliderRatePAID, fSliderRatePA, "{1}%")
       EABRatePA.SetValue(fSliderRatePA)
   elseif (option == SliderStolenID)
       fSliderStolen = value
       SetSliderOptionValue(SliderStolenID, fSliderStolen, "{1}%")
       EABStolen.SetValue(fSliderStolen)
   elseif (option == SliderFollowerBreakModeID)
       fSliderFollowerBreakMode = value
       SetSliderOptionValue(SliderFollowerBreakModeID, fSliderFollowerBreakMode, "{0}")
       EABFollowerBreakMode.SetValue(fSliderFollowerBreakMode)
   elseif (option == SliderNpcBreakModeID)
       fSliderNpcBreakMode = value
       SetSliderOptionValue(SliderNpcBreakModeID, fSliderNpcBreakMode, "{0}")
       EABNpcBreakMode.SetValue(fSliderNpcBreakMode)
   elseif (option == SliderBreakModeID)
       fSliderBreakMode = value
       SetSliderOptionValue(SliderBreakModeID, fSliderBreakMode, "{0}")
       EABBreakMode.SetValue(fSliderBreakMode)
   elseif (option == SliderPlayerIntervalID)
       fSliderPlayerInterval = value
       SetSliderOptionValue(SliderPlayerIntervalID, fSliderPlayerInterval, "{1}b")
       EABPlayerInterval.SetValue(fSliderPlayerInterval)
   elseif (option == SliderFollowerIntervalID)
       fSliderFollowerInterval = value
       SetSliderOptionValue(SliderFollowerIntervalID, fSliderFollowerInterval, "{1}b")
       EABFollowerInterval.SetValue(fSliderFollowerInterval)
   elseif (option == SliderFollowerSexID)
       fSliderFollowerSex = value
       SetSliderOptionValue(SliderFollowerSexID, fSliderFollowerSex, "{0}")
       EABFollowerSex.SetValue(fSliderFollowerSex)
   elseif (option == SliderNpcSexID)
       fSliderNpcSex = value
       SetSliderOptionValue(SliderNpcSexID, fSliderNpcSex, "{0}")
       EABNpcSex.SetValue(fSliderNpcSex)
   elseif (option == SliderLostTimeIntervalID)
       fSliderLostTimeInterval = value
       SetSliderOptionValue(SliderLostTimeIntervalID, fSliderLostTimeInterval, "{0}")
       EABLostTimeInterval.SetValue(fSliderLostTimeInterval)
   elseif (option == SliderDegradationNumID)
       fSliderDegradationNum = value
       SetSliderOptionValue(SliderDegradationNumID, fSliderDegradationNum, "{3}")
       EABDegradationNum.SetValue(fSliderDegradationNum)
   elseif (option == SliderDegradationTimesID)
       fSliderDegradationTimes = value
       SetSliderOptionValue(SliderDegradationTimesID, fSliderDegradationTimes, "{2}?")
       EABDegradationTimes.SetValue(fSliderDegradationTimes)
   elseif (option == SliderEquipIntervalID)
       fSliderEquipInterval = value
       SetSliderOptionValue(SliderEquipIntervalID, fSliderEquipInterval, "{2}")
       EABEquipInterval.SetValue(fSliderEquipInterval)
   elseif (option == SliderFEquipIntervalID)
       fSliderFEquipInterval = value
       SetSliderOptionValue(SliderFEquipIntervalID, fSliderFEquipInterval, "{2}")
       EABFEquipInterval.SetValue(fSliderFEquipInterval)
   elseif (option == SliderFxVolumeID)
       fSliderFxVolume = value
       SetSliderOptionValue(SliderFxVolumeID, fSliderFxVolume, "{1}")
       EABFxVolume.SetValue(fSliderFxVolume)
   else
       int idx = SliderPriorityID.Find(option)
       if (idx >= 0)
           fSliderPriority[idx] = value
           SetSliderOptionValue(SliderPriorityID[idx], value, "{0}")
           STPriority()
       endif

       idx = SliderAltPriorityID.Find(option)
       if (idx >= 0)
           fSliderAltPriority[idx] = value
           SetSliderOptionValue(SliderAltPriorityID[idx], value, "{0}")
           STAltPriority()
       endif
   endIf
EndEvent

;ftHg̐ݒ(FL?ɌĂяoCxg)
Event OnOptionDefault(int option)
  If(option == ToggleLogModeID)
      if (!bToggleLogMode)
          bToggleLogMode = true
          SetToggleOptionValue(ToggleLogModeID, bToggleLogMode)
          EABLogMode.SetValue(1)
      endif
  ElseIf(option == ToggleDeathModeID)
      if (!bToggleDeathMode)
          bToggleDeathMode = true
          SetToggleOptionValue(ToggleDeathModeID, bToggleDeathMode)
          EABDeathMode.SetValue(1)
      endif
  ElseIf(option == ToggleSkimpyDeathModeID)
      if (!bToggleSkimpyDeathMode)
          bToggleSkimpyDeathMode = true
          SetToggleOptionValue(ToggleSkimpyDeathModeID, bToggleSkimpyDeathMode)
          EABSkimpyDeathMode.SetValue(1)
      endif
  ElseIf(option == ToggleSkimpyArmorMissingModeID)
      if (!bToggleSkimpyArmorMissingMode)
          bToggleSkimpyArmorMissingMode = true
          SetToggleOptionValue(ToggleSkimpyArmorMissingModeID, bToggleSkimpyArmorMissingMode)
          EABPlayerTempArmorMissing.SetValue(1)
      endif
  ElseIf(option == ToggleLostTimeModeID)
      if (bToggleLostTimeMode)
          bToggleLostTimeMode = false
          SetToggleOptionValue(ToggleLostTimeModeID, bToggleLostTimeMode)
          EABLostTimeMode.SetValue(0)
      endif
  ElseIf(option == ToggleSwdBrokenModeID)
      if (bToggleSwdBrokenMode)
          bToggleSwdBrokenMode = false
          SetToggleOptionValue(ToggleSwdBrokenModeID, bToggleSwdBrokenMode)
          EABSwdBrokenMode.SetValue(0)
      endif
  ElseIf(option == ToggleEnchProtectID)
      if (bToggleEnchProtect)
          bToggleEnchProtect = false
          SetToggleOptionValue(ToggleEnchProtectID, bToggleEnchProtect)
          EABEnchProtect.SetValue(0)
      endif
  ElseIf(option == ToggleNpcEnableID)
      if (bToggleNpcEnable)
          bToggleNpcEnable = false
          SetToggleOptionValue(ToggleNpcEnableID, bToggleNpcEnable)
          EABNpcEnable.SetValue(0)
      endif
  ElseIf(option == ToggleReEquipModeID)
      if (bToggleReEquipMode)
          bToggleReEquipMode = false
          SetToggleOptionValue(ToggleReEquipModeID, bToggleReEquipMode)
          EABReEquipMode.SetValue(0)
      endif
  ElseIf(option == ToggleFReEquipModeID)
      if (bToggleFReEquipMode)
          bToggleFReEquipMode = false
          SetToggleOptionValue(ToggleFReEquipModeID, bToggleFReEquipMode)
          EABFReEquipMode.SetValue(0)
      endif
  ElseIf(option == ToggleFxEnableID)
      if (!bToggleFxEnable)
          bToggleFxEnable = true
          SetToggleOptionValue(ToggleFxEnableID, bToggleFxEnable)
          EABFxEnable.SetValue(1)
      endif
  ElseIf(option == ToggleFxEnableFollowerID)
      if (bToggleFxEnableFollower)
          bToggleFxEnableFollower = false
          SetToggleOptionValue(ToggleFxEnableFollowerID, bToggleFxEnableFollower)
          EABFxEnableFollower.SetValue(0)
      endif
  ElseIf(option == ToggleFxEnableNPCID)
      if (bToggleFxEnableNPC)
          bToggleFxEnableNPC = false
          SetToggleOptionValue(ToggleFxEnableNPCID, bToggleFxEnableNPC)
          EABFxEnableNPC.SetValue(0)
      endif
  Elseif(option == SliderRateID)
      fSliderRate = 15.0
      SetSliderOptionValue(SliderRateID, fSliderRate, "{1}%")
      EABRate.SetValue(fSliderRate)
  Elseif(option == SliderRatePAID)
      fSliderRatePA = 80.0
      SetSliderOptionValue(SliderRatePAID, fSliderRatePA, "{1}%")
      EABRatePA.SetValue(fSliderRatePA)
  Elseif(option == SliderStolenID)
      fSliderStolen = 0.0
      SetSliderOptionValue(SliderStolenID, fSliderStolen, "{1}%")
      EABStolen.SetValue(fSliderStolen)
  Elseif(option == SliderFollowerBreakModeID)
      fSliderFollowerBreakMode = 0
      SetSliderOptionValue(SliderFollowerBreakModeID, fSliderFollowerBreakMode, "{0}")
      EABFollowerBreakMode.SetValue(fSliderFollowerBreakMode)
  Elseif(option == SliderNpcBreakModeID)
      fSliderNpcBreakMode = 0
      SetSliderOptionValue(SliderNpcBreakModeID, fSliderNpcBreakMode, "{0}")
      EABNpcBreakMode.SetValue(fSliderNpcBreakMode)
  Elseif(option == SliderBreakModeID)
      fSliderBreakMode = 0
      SetSliderOptionValue(SliderBreakModeID, fSliderBreakMode, "{0}")
      EABBreakMode.SetValue(fSliderBreakMode)
  Elseif(option == SliderPlayerIntervalID)
      fSliderPlayerInterval = 2.0
      SetSliderOptionValue(SliderPlayerIntervalID, fSliderPlayerInterval, "{1}b")
      EABPlayerInterval.SetValue(fSliderPlayerInterval)
  Elseif(option == SliderLostTimeIntervalID)
      fSliderLostTimeInterval = 5.0
      SetSliderOptionValue(SliderLostTimeIntervalID, fSliderLostTimeInterval, "{0}")
      EABLostTimeInterval.SetValue(fSliderLostTimeInterval)
  Elseif(option == SliderFollowerIntervalID)
      fSliderFollowerInterval = 2.0
      SetSliderOptionValue(SliderFollowerIntervalID, fSliderFollowerInterval, "{1}b")
      EABFollowerInterval.SetValue(fSliderFollowerInterval)
  Elseif(option == SliderDegradationNumID)
      fSliderDegradationNum = 0.100
      SetSliderOptionValue(SliderDegradationNumID, fSliderDegradationNum, "{3}")
      EABDegradationNum.SetValue(fSliderDegradationNum)
  Elseif(option == SliderDegradationTimesID)
      fSliderDegradationTimes = 1.00
      SetSliderOptionValue(SliderDegradationTimesID, fSliderDegradationTimes, "{2}?")
      EABDegradationTimes.SetValue(fSliderDegradationTimes)
  Elseif(option == SliderEquipIntervalID)
      fSliderEquipInterval = 0.25
      SetSliderOptionValue(SliderEquipIntervalID, fSliderEquipInterval, "{2}")
      EABEquipInterval.SetValue(fSliderEquipInterval)
  Elseif(option == SliderFEquipIntervalID)
      fSliderFEquipInterval = 0.25
      SetSliderOptionValue(SliderFEquipIntervalID, fSliderFEquipInterval, "{2}")
      EABFEquipInterval.SetValue(fSliderFEquipInterval)
  Elseif(option == SliderFollowerSexID)
      fSliderFollowerSex = 2
      SetSliderOptionValue(SliderFollowerSexID, fSliderFollowerSex, "{0}")
      EABFollowerSex.SetValue(fSliderFollowerSex)
  Elseif(option == SliderNpcSexID)
      fSliderNpcSex = 2
      SetSliderOptionValue(SliderNpcSexID, fSliderNpcSex, "{0}")
      EABNpcSex.SetValue(fSliderNpcSex)
  Elseif(option == SliderFxVolumeID)
      fSliderFxVolume = 1.0
      SetSliderOptionValue(SliderFxVolumeID, fSliderFxVolume, "{1}")
      EABFxVolume.SetValue(fSliderFxVolume)
  ElseIf(option == ToggleFollowerModeID)
      if (bToggleFollowerMode)
          bToggleFollowerMode = false
          SetToggleOptionValue(ToggleFollowerModeID, bToggleFollowerMode)
          EABFollowerMode.SetValue(0)
      endif
  ElseIf(option == TogglePriorityModeID)
      if (bTogglePriorityMode)
          bTogglePriorityMode = false
          SetToggleOptionValue(TogglePriorityModeID, bTogglePriorityMode)
          EABPriorityMode.SetValue(0)
      endif
  ElseIf(option == ToggleAltPriorityModeID)
      if (bToggleAltPriorityMode)
          bToggleAltPriorityMode = false
          SetToggleOptionValue(ToggleAltPriorityModeID, bToggleAltPriorityMode)
          EABAltPriorityMode.SetValue(0)
      endif
  Else
       int idx = ToggleSlotID.Find(option)
       if (idx >= 0)
           if ( idx <= 13 ) ;slot 30-43
               IgnoreArmorSlot(EABSlotMask, EABSlotMaskB, idx + 30, True)
               SetToggleOptionValue(option, True)
           else
               IgnoreArmorSlot(EABSlotMask, EABSlotMaskB, idx + 30, False)
               SetToggleOptionValue(option, False)
           endif
       endif
  EndIf
EndEvent

;J??ɉɏoeLXg̐ݒ
Event OnOptionHighlight(int option)
  If(option == SliderBreakModeID)
       SetInfoText("Set a method for armor breakB0:Unequip 1:Remove 2:Drop 3:Random")
  ElseIf(option == ToggleLogModeID)
       SetInfoText("When your armor is worn out or broken, display text messages.")
  ElseIf(option == ToggleLostTimeModeID)
       SetInfoText("You can't equip armor right after the armor is taken off.(Only applied to slot32)")
  ElseIf(option == SliderLostTimeIntervalID)
       SetInfoText("The time interval after Armor Break(Game Hour)")
  ElseIf(option == ToggleEnchProtectID)
       SetInfoText("No enchanted armor will be broken.")
  Elseif(option == SliderRateID)
       SetInfoText("Armor break chance when you get hit.")
  Elseif(option == SliderRatePAID)
       SetInfoText("Armor break chance when you get hit from power attack.")
  Elseif(option == ToggleSwdBrokenModeID)
       SetInfoText("When armor is broken, you can mend it and use it again.(Only for PC)")
  Elseif(option == ToggleFollowerModeID)
       SetInfoText("Apply the effect to followers(After hiring, you need to talk to them one time at least.)")
  Elseif(option == ToggleNpcEnableID)
       SetInfoText("Apply the effect to NPCs(followers are excluded)")
  Elseif(option == ToggleDegradationModeID)
       SetInfoText("Tempered armor will be worn out instead of being broken.")
  Elseif(option == SliderDegradationNumID)
       SetInfoText("Degradation Speed from normal hit.")
  Elseif(option == SliderDegradationTimesID)
       SetInfoText("Degradation Speed from power attack.")
  Elseif(option == SliderStolenID)
       SetInfoText("Chance of being stolen when getting hit.")
  Elseif(option == SliderFollowerBreakModeID)
       SetInfoText("Set Follower's armor break systemB0:Unequip 1:Remove 2:Drop 3:Random")
  Elseif(option == SliderNpcBreakModeID)
       SetInfoText("Set NPC's armor break systemB0:Unequip 1:Remove 2:Drop 3:Random")
  Elseif(option == TogglePriorityModeID)
       SetInfoText("Set the priorities slots for armor break")
  Elseif(option == ToggleAltPriorityModeID)
       SetInfoText("Set the alt priorities")
  Elseif(option == ToggleUnblockModeID)
       SetInfoText("Armor break will be activated even you are in blocking")
  Elseif(option == SliderPlayerIntervalID)
       SetInfoText("Time interval after armor break occurs for players")
  Elseif(option == SliderFollowerIntervalID)
       SetInfoText("Time interval after armor break occurs for followers")
  Elseif(option == SliderFollowerSexID)
       SetInfoText("Set followers sex that will be affected 0:Male 1:Female 2:All")
  Elseif(option == SliderNpcSexID)
       SetInfoText("Set npc's sex that will be affected 0:Male 1:Female 2:All")
  Elseif(option == ToggleReEquipModeID)
       SetInfoText("After a certain amount of time, npcs will equip their unequipped gear again.")
  Elseif(option == SliderEquipIntervalID)
       SetInfoText("Set time for npcs to reuse their unequipped armor after armor break.(Game Hour)")
  Elseif(option == ToggleFReEquipModeID)
       SetInfoText("After a certain amount of time, followers will equip their unequipped gear again.")
  Elseif(option == SliderFEquipIntervalID)
       SetInfoText("Set time for followers to reuse their unequipped armor after armor break.(Game Hour)")
  Elseif(option == SliderFxVolumeID)
       SetInfoText("Armor Break Volume Setting")
  Elseif(option == ToggleFxEnableID)
       SetInfoText("Armor Break Player Sound")
  Elseif(option == ToggleFxEnableFollowerID)
       SetInfoText("Armor Break Follower Sound")
  Elseif(option == ToggleFxEnableNPCID)
       SetInfoText("Armor Break NPC Sound")
  ElseIf(option == ToggleDeathModeID)
       SetInfoText("If the toggle is on, and when you die, your body armor parts will be unequipped and be dropped.")
  ElseIf(option == ToggleSkimpyDeathModeID)
       SetInfoText("Only Skimpy Armor will be unequipped when you die.")
  ElseIf(option == ToggleSkimpyArmorMissingModeID)
       SetInfoText("Your armor can be unequipped and vanished during a battle instead of being degraded or broken.")
  ElseIf(option == SliderMissingArmorRateID)
       SetInfoText("The chance your armor is unequipped and vanished from your inventory for a brief period of time.")
  Else
       int idx = SliderPriorityID.Find(option)
       if (idx >= 0)
           SetInfoText("1:Easily breakable   <------>   8:Rarely breakable")
       endif

       idx = SliderAltPriorityID.Find(option)
       if (idx >= 0)
           SetInfoText("If a slot in Priority List is not available(unequipped), seek for another slot in Alt Priority List.")
       endif
  EndIf
EndEvent
Bool[] Function GetUnignoredArmorSlots(GlobalVariable IgnoredArmorSlotsMask, GlobalVariable IgnoredArmorSlotsMaskB)
	Bool[] ArmorSlots = new Bool[32]

    Int CurrentArmorSlotsMaskB = Math.LeftShift(IgnoredArmorSlotsMaskB.GetValue() As Int, 24)
	Int CurrentArmorSlotsMaskA = IgnoredArmorSlotsMask.GetValue() As Int
	Int CurrentIgnoredArmorSlotsMask = Math.LogicalOr(CurrentArmorSlotsMaskA, CurrentArmorSlotsMaskB)
	
	Int Index = ArmorSlots.Length
	While Index
		Index -= 1
		Int ArmorSlotMask = Armor.GetMaskForSlot(Index + 30)
		If Math.LogicalAnd(ArmorSlotMask, CurrentIgnoredArmorSlotsMask) == ArmorSlotMask
			ArmorSlots[Index] = True
		Else
			ArmorSlots[Index] = False
		EndIf
	EndWhile
	
	Return ArmorSlots
EndFunction

Function GTPriority()
	int count = 0
	int ct = 0
	int index = 0
	int[] priwork = new int[4]
	priwork[0] = EABPriority1.GetValue() as int
	priwork[1] = EABPriority2.GetValue() as int
	priwork[2] = EABPriority3.GetValue() as int
	priwork[3] = EABPriority4.GetValue() as int
	
	while ct < 4
		count = 0
		while count < 8
			fSliderPriority[index] = Math.LogicalAnd(Math.RightShift(priwork[ct],3*count), 0x00000007) + 1
			index += 1
			count += 1
		EndWhile
		ct += 1
	EndWhile
EndFunction

Function STPriority()
	int[] priwork = new int[4]
	int work = 0
	int count = 0
	int index = 0
	int ct = 0
	
	while ct < 4
		priwork[ct] = 0
		count = 0
		while count < 8
			work = fSliderPriority[index] as int
			work -= 1
			priwork[ct] = Math.LogicalOr(Math.LeftShift(work, 3*count), priwork[ct])
			index += 1
			count += 1
		EndWhile
		ct += 1
	EndWhile
	EABPriority1.SetValue(priwork[0])
	EABPriority2.SetValue(priwork[1])
	EABPriority3.SetValue(priwork[2])
	EABPriority4.SetValue(priwork[3])
EndFunction

Function GTAltPriority()
	int count = 0
	int ct = 0
	int index = 0
	int[] priwork = new int[8]
	priwork[0] = EABAltPriority1.GetValue() as int
	priwork[1] = EABAltPriority2.GetValue() as int
	priwork[2] = EABAltPriority3.GetValue() as int
	priwork[3] = EABAltPriority4.GetValue() as int
	priwork[4] = EABAltPriority5.GetValue() as int
	priwork[5] = EABAltPriority6.GetValue() as int
	priwork[6] = EABAltPriority7.GetValue() as int
	priwork[7] = EABAltPriority8.GetValue() as int
	
	while ct < 8
		count = 0
		while count < 4
			fSliderAltPriority[index] = Math.LogicalAnd(Math.RightShift(priwork[ct],6*count), 0x0000003f)
			index += 1
			count += 1
		EndWhile
		ct += 1
	EndWhile
EndFunction

Function STAltPriority()
	int[] priwork = new int[8]
	int work = 0
	int count = 0
	int index = 0
	int ct = 0
	
	while ct < 8
		priwork[ct] = 0
		count = 0
		while count < 4
			work = fSliderAltPriority[index] as int
			priwork[ct] = Math.LogicalOr(Math.LeftShift(work, 6*count), priwork[ct])
			index += 1
			count += 1
		EndWhile
		ct += 1
	EndWhile
	EABAltPriority1.SetValue(priwork[0])
	EABAltPriority2.SetValue(priwork[1])
	EABAltPriority3.SetValue(priwork[2])
	EABAltPriority4.SetValue(priwork[3])
	EABAltPriority5.SetValue(priwork[4])
	EABAltPriority6.SetValue(priwork[5])
	EABAltPriority7.SetValue(priwork[6])
	EABAltPriority8.SetValue(priwork[7])
EndFunction

Function IgnoreArmorSlot(GlobalVariable IgnoredArmorSlotsMask, GlobalVariable IgnoredArmorSlotsMaskB, Int ArmorSlot, Bool Ignore)
	Int ArmorSlotMask = Armor.GetMaskForSlot(ArmorSlot)
    Int CurrentArmorSlotsMaskB = Math.LeftShift(IgnoredArmorSlotsMaskB.GetValue() As Int, 24)
	Int CurrentArmorSlotsMaskA = IgnoredArmorSlotsMask.GetValue() As Int
	Int CurrentIgnoredArmorSlotsMask = Math.LogicalOr(CurrentArmorSlotsMaskA, CurrentArmorSlotsMaskB)
;	Int CurrentIgnoredArmorSlotsMask = IgnoredArmorSlotsMask.GetValue() As Int
	
	Int NewIgnoredArmorSlotsMask
	If Ignore == False
		NewIgnoredArmorSlotsMask = Math.LogicalOr(ArmorSlotMask, CurrentIgnoredArmorSlotsMask)
	Else
		NewIgnoredArmorSlotsMask = Math.LogicalXor(ArmorSlotMask, CurrentIgnoredArmorSlotsMask)
	EndIf
	
	IgnoredArmorSlotsMask.SetValue(Math.LogicalAnd(NewIgnoredArmorSlotsMask, 0x00ffffff))
	IgnoredArmorSlotsMaskB.SetValue(Math.RightShift(NewIgnoredArmorSlotsMask, 24))
EndFunction
Event OnVersionUpdate(Int a_version)
	;Debug.Notification("[EAB]:MCM Update");
	OnConfigInit()
EndEvent
